!DIR$ FIXEDFORMLINESIZE:132
      include 'include/mkl_vsl.f'
      include 'include/math_blocks.f'
      include 'include/rte_blocks.f'
      include 'include/header_types.f'
      include 'include/file_types.f'

      program mc
      use rte_blocks
      use math_blocks
      implicit none
      integer*4 errcode

 400  format(a41, i4, a10)

c
c---------- Reading input parameters -----------------------------
c
      call check_pars(errcode)

      if(errcode .gt. 0)      then
         write(*,400) 'There have been errors on input: errcode=', errcode, ' ; exiting'
         stop
      else if(errcode .lt. 0) then
         write(*,*) 'There have been warnings on input; pausing'
         pause
      else
         write(*,*) 'Input has been checked for sanity and is OK'
      end if

      call report_pars('*mc*')

      call rescale()

      write(*,*) '     ------------------------------------'
      write(*,*) 'Compute_u    :', Compute_u
      write(*,*) 'Compute_J    :', Compute_J
      write(*,*) 'Compute_I    :', Compute_I

      open(unit=6,carriagecontrol ='fortran')

      nmem = 0

c
c---------- Selecting and running a job -----------------------------
c

      IF(Collimated_Source) THEN

         call select_job_csrc()

      ELSE 

         call select_job_isrc()
  
      END IF

      stop
      end
