!DIR$ FIXEDFORMLINESIZE:132
      subroutine dd_cyl_I_2D(mode, errcode)
      use rte_blocks
      implicit none

      integer*4, intent(in)  :: mode
      integer*4, intent(out) :: errcode

      integer*8   irec, n, n_max

      real*4      fun
      real*4      z, z_of_iz
      real*4      scth, scth_of_iscth

      integer*4   k, l, iz, iscth

      integer*4   ind

      real(nword), allocatable, dimension(:)   :: v
      real(nword), allocatable, dimension(:,:) :: I

      errcode = 0

      n_max = int8(Nscth)*int8(lz)

      allocate(v(1:nline))
      allocate(I(1:Nscth,1:lz))

      irec = 2
      read(80,rec=irec,err=1002) (v(l), l=1,nline)

      k = 0
      n = 0
      do 1, iz   =1,lz
      do 1, iscth=1,Nscth
      k=k+1
      n=n+1
      I(iscth,iz) = v(k)
      if(k .eq. nline) then
         if(n .lt. n_max) then
            irec = irec+1 
            read(80,rec=irec,err=1002) (v(l), l=1,nline)
            k = 0
         else
            continue
         end if
      end if
 1    continue

      close(unit=80,err=1003)
      write(*,*) irec, 'records successfully read'

      deallocate(v)

 200  continue

 100  continue

      write(*,*) '***** I(r;s) = I(C, z), where C=cos(theta). Make a choice: ****'
      write(*,*) '   Dump all available data into an ASCII file               [1]'
      write(*,*) '   Display I(C=C0; z   ) as a function of z                 [2]'
      write(*,*) '   Display I(C   ; z=z0) as a function of C                 [3]'
      write(*,*) '***************************************************************'

      read(*,*) ind
      if((ind .lt. 1) .or. (ind .gt. 3)) then
         write(*,*) 'Response is outside of range or incorrect, ind=', ind
         goto 100
      end if
c
c------------- Getting integer idexes -------------------------
c
      if      (mode .eq. 1) then
         call gip_cyl_I_2D(ind, iscth, iz)
      else if (mode .eq. 2) then
         call gii_cyl_I_2D(ind, iscth, iz)
      else
         errcode = 1
         return
      end if
c
c------------- Writing data out --------------------------------------
c

      IF     (ind .eq. 1) THEN

         open(unit=70, file='I_C_z',status='unknown')

         do 11, iz=1,Lz
         z = z_of_iz(iz)
         do 11, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,iz)
         write(70,*) scth, z, fun
 11      continue

         write(*,*) '........ Output written to file "I_z" '
         write(*,*) '.................. Format: scth, z, I '

      ELSE IF(ind .eq. 2) THEN

         open(unit=70, file='I_z',status='unknown')

         do 12, iz=1,Lz
         z = z_of_iz(iz)
         fun = I(iscth,iz)
         write(70,*) z, fun
 12      continue

         write(*,*) '....... Output written to file "I_z" '
         write(*,*) '....................... Format: z, I '

      ELSE IF(ind .eq. 3) THEN

         open(unit=70, file='I_C',status='unknown')

         do 13, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,iz)
         write(70,*) scth, fun
 13      continue

         write(*,*) '......... Output written to file "I_C" '
         write(*,*) '...................... Format: scth, I '

      ELSE

         write(*,*) 'Incorrect index (should be 1<=ind<=5); please try again'
         goto 100

      END IF

      close(unit=70)


      write(*,*) 'Make another choice to display more data'
      write(*,*) '=============================================================================='
      write(*,*) '=============================================================================='

      goto 100

      return

 1002 continue
      write(*,*) 'dd_I_CYL: Error reading binary data'
      errcode = 1002
      return

 1003 continue
      write(*,*) 'dd_I_CYL: Error closing input file'
      errcode = 1003
      return

      end
