!DIR$ FIXEDFORMLINESIZE:132
      subroutine upd_pnts_sur_cyl_T(xw, yw, zw, dx, dy, dz, sx, sy, sz)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none

      real*4, intent(in) :: xw, yw, zw
      real*4, intent(in) :: sx, sy, sz
      real*4, intent(in) :: dx, dy, dz

      real(nword) szi, hzi, sfi, shi

      real*4    zet, xc, yc, rho, srho, arg, den, sphi, ux, uy, spx, spy
      integer*4 irho, irho_of_rho, iscth, isphi, iscth_of_scth, isphi_of_sphi

      szi = du/sz
      hzi = dhalf*szi
      sfi = sphifrac*szi
      shi = sphihrac*szi

      zet = (zw - zsmax)/dz

      xc  = xw - zet*dx
      yc  = yw - zet*dy
      rho = sqrt(xc*xc + yc*yc)
      if(rho .ge. rhomax) return
      irho = irho_of_rho(rho)

      if(compute_u) then 
         uT1D(irho) = uT1D(irho) + szi
      end if

      if(compute_J) then 
         if(irho .eq. 1) goto 1
         ux = xc/rho
         uy = yc/rho
         srho = sx*ux + sy*uy
         JT2D(1,irho) = JT2D(1,irho) + srho*szi
 1       continue
         JT2D(2,irho) = JT2D(2,irho) + du
      end if

      if(compute_I) then 
c         if(sz .lt. scth_min) return
c         if(sz .gt. scth_max) return
         iscth = iscth_of_scth(sz)

         if((rho .le. small) .or. (abs(sz*sz-ru) .lt. small)) then
            IT3D(iscth,2:Nsphi-1,irho) = IT3D(iscth,2:Nsphi-1,irho) + sfi  ! =sphifrac*szi
            IT3D(iscth,1        ,irho) = IT3D(iscth,1        ,irho) + shi  ! =sphihrac*szi
            IT3D(iscth,  Nsphi  ,irho) = IT3D(iscth,  Nsphi  ,irho) + shi  ! =sphihrac*szi
         else
            den = sqrt(sx*sx + sy*sy)
            spx = sx/den
            spy = sy/den
            den = sqrt(xc*xc + yc*yc)
            arg = (xc*spx + yc*spy)/den
            if(arg .gt.  ru) arg =  ru
            if(arg .lt. -ru) arg = -ru
            sphi = acos(arg) / pi
            isphi = isphi_of_sphi(sphi)
            IT3D(iscth,isphi,irho) = IT3D(iscth,isphi,irho) + hzi  ! =dhalf*szi
            isphi = isphi_of_sphi(two-sphi)
            IT3D(iscth,isphi,irho) = IT3D(iscth,isphi,irho) + hzi  ! =dhalf*szi
         end if
      end if

      return
      end
